.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib

; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc   PROTO : HWND, : UINT, : WPARAM, : LPARAM
WindowProc    PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  		      equ 101
IDI_ICON              equ 200
IDC_EXIT              equ 102
IDC_WINDOWBUTTON      equ 103
IDC_WINDOW            equ 104

; Required data

.data
szTitle     db "Centering a window on another window", 0
szTitle2    db "Another window",0

.data?

hInstance HINSTANCE ?
hIcon     HICON     ?
PosRct	  RECT	   <?>
.code

start:

INVOKE InitCommonControls

INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ---------------------------------------------
;   Call the dialog box stored in resource file
; --------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0

; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

 .IF uMsg == WM_INITDIALOG
 
  INVOKE SetWindowText, hWnd, addr szTitle 
  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  
    .ELSEIF uMsg == WM_COMMAND
     
       
      .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 
   .ENDIF 
  
    .IF wParam == IDC_EXIT 
      INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0

    .ENDIF
    
    .IF wParam == IDC_WINDOWBUTTON 
invoke GetWindowRect,hWnd,addr PosRct 	
invoke DialogBoxParam,hInstance,IDC_WINDOW,hWnd,addr WindowProc,0
        

    .ENDIF

    xor eax,eax
  ret
DialogProc endp

; Window procedure                                   
;-------------------------------------------------------------------------------------------------
WindowProc proc  hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM


    mov		eax,uMsg
    .IF eax == WM_INITDIALOG
    INVOKE SetWindowText, hWnd, addr szTitle2
    mov eax,PosRct.left
	add eax,38; position relative to main window adjustment side to side
	mov ebx,PosRct.top
	add ebx,5 ; position relative to main window adjustment up & down
	INVOKE MoveWindow,hWnd,eax,ebx,280,180,TRUE ; sets relative position to main window TRUE!!!
	;Also Controls final size of about Dialog!!!


    .ELSEIF eax == WM_COMMAND
    mov		eax,wParam
	and		eax,0FFFFh

 .ELSEIF eax == WM_CLOSE 
    	INVOKE EndDialog, hWnd, 0
   .ENDIF 


    xor eax,eax
  ret                
WindowProc endp
end start